#ifndef GETOPT_R_C
#define GETOPT_R_C
#include <string.h>
#include "getopt_r.h"

static char *getopt_r_empty = "";	/* just a 0 byte space holder */

void getopt_r_init(struct getopt_r *o, const char *optstr) {
    o->ind = 1;
    o->p   = getopt_r_empty;
    o->str = (char *) optstr;
}

int getopt_r(struct getopt_r *o, int n, char **v) {
    char *q;				  /* ptr to option char */

    if (!*o->p) {			  /* update scanning pointer */
	if (o->ind >= n || *(o->p = v[o->ind]) != '-') {  /* no more opts */
	    o->p = getopt_r_empty;
	    return -1;
	}
	if (o->p[1] && *++o->p == '-') {  /* "--", hence DONE */
	    o->ind++;
	    o->p = getopt_r_empty;
	    return -1;
	}
    }
    if ((o->opt = *o->p++) == ':' || !(q = strchr(o->str, o->opt))) {
	if (o->opt == '-')
	    return -1;			  /* DONE */
	if (!*o->p)
	    o->ind++;
	return -2;
    }
    if (*++q != ':') {			  /* no argument for this opt */
	o->arg = (char *)0;
	if (!*o->p)
	    o->ind++;
    } else {				  /* need an argument */
	if (*o->p)			  /* in this v[] element */
	    o->arg = o->p;
	else if (++o->ind >= n) {	  /* no arg in last v[] & no more v! */
	    o->p = getopt_r_empty;
	    return -3;			  /* MISSING ARGUMENT */
	} else				  /* arg comes from next v[] */
	    o->arg = v[o->ind];
	o->p = getopt_r_empty;
	o->ind++;
    }
    return o->opt;			 /* return option letter */
}
#endif /* GETOPT_R_C */
